--****************************************  DURAL ********************************************
--** we want to get back the "totalTeddedArea"

local oldTedderUpdateTick = Tedder.updateTick;
Tedder.updateTick = function(self, dt)

		if not self.isRealistic then
			return oldTedderUpdateTick(self, dt);
		end;


       self.wasToFast = false;
       if self:getIsActive() then
	   
			--****************************************  DURAL ********************************************
			--** reset totalTeddedArea
			self.realLastTeddedArea = 0;
	   
		
	   
           local hasGroundContact = false;
           local x,y,z = getWorldTranslation(self.groundReferenceNode);
           local terrainHeight = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x, 0, z);
           if terrainHeight+self.groundReferenceThreshold >= y then
               hasGroundContact = true;
           end;
		   
		   --print(self.time .. " Tedder.updateTick - hasGroundContact="..tostring(hasGroundContact));
		   
           if hasGroundContact then
               local foldAnimTime = self.foldAnimTime;
               if self.isTurnedOn then

			   --****************************************  DURAL ********************************************
			   --** variable speed limit
			   --** self.wasToFast = needed client side too
					--print(self.time .. " Tedder.updateTick - checking tooFast - speed = " .. tostring(math.abs(self.lastSpeed)*3600) .. " - max speed =" .. tostring(self.realWorkingSpeedLimit) .. " - checkSpeedLimit="..tostring(self:doCheckSpeedLimit()));
                   local toFast = self:doCheckSpeedLimit() and math.abs(self.lastSpeed)*3600 > self.realWorkingSpeedLimit;
				   self.wasToFast = toFast;
                   if self.isServer then
                       local cuttingAreasSend = {};
                       if not toFast then
                           local numAreas = math.min(table.getn(self.tedderDropAreas), table.getn(self.cuttingAreas));
                           for i=1, numAreas do
                               local cuttingArea = self.cuttingAreas[i];
                               if self:getIsAreaActive(cuttingArea) then
                                   local x,y,z = getWorldTranslation(cuttingArea.start);
                                   local x1,y1,z1 = getWorldTranslation(cuttingArea.width);
                                   local x2,y2,z2 = getWorldTranslation(cuttingArea.height);
   
                                   local dropArea = self.tedderDropAreas[i];
                                   local dx,dy,dz = getWorldTranslation(dropArea.start);
                                   local dx1,dy1,dz1 = getWorldTranslation(dropArea.width);
                                   local dx2,dy2,dz2 = getWorldTranslation(dropArea.height);
   
                                   table.insert(cuttingAreasSend, {x,z,x1,z1,x2,z2,dx, dz, dx1, dz1, dx2, dz2, 0, i});
                               end;
                           end;
                           if (table.getn(cuttingAreasSend) > 0) then
--****************************************  DURAL ********************************************
--** update totalTeddedArea			
                               local cuttingAreasSend, bitType, teddedArea = TedderAreaEvent.runLocallyEX1(cuttingAreasSend, self.accumulatedCuttingAreaValues);
							   self.realLastTeddedArea = teddedArea;							  
							   
                               if (table.getn(cuttingAreasSend) > 0) then
                                   for i=1, table.getn(cuttingAreasSend) do
                                       local cuttingArea = self.cuttingAreas[cuttingAreasSend[i][14] ];
   
                                       if cuttingArea.grassParticleSystemIndex ~= nil then
                                           local ps = self.grassParticleSystems[cuttingArea.grassParticleSystemIndex+1];
                                           if ps ~= nil then
                                               ps.disableTime = self.time + 300;
                                               if not ps.isEnabled then
                                                   ps.isEnabled = true;
                                                   self:raiseDirtyFlags(self.tedderParticleSystemFlag);
                                                   if self.isClient then
                                                       Utils.setEmittingState(ps.ps, true);
                                                   end;
                                               end;
                                           end;
                                       end;
                                   end;
                                   g_server:broadcastEvent(TedderAreaEvent:new(cuttingAreasSend, bitType));
                               end;
                           end;
                       end;
                   end;
                   
               end;
   
               for k,v in pairs(self.speedRotatingParts) do
                   if foldAnimTime == nil or (foldAnimTime <= v.foldMaxLimit and foldAnimTime >= v.foldMinLimit) then
                       rotate(v.node, v.rotationSpeedScale * self.lastSpeedReal * self.movingDirection * dt, 0, 0);
                   end;
               end;
           end;
           if self.isServer then
               for k,v in pairs(self.grassParticleSystems) do
                   if self.time > v.disableTime then
                       if v.isEnabled then
                           v.isEnabled = false;
                           self:raiseDirtyFlags(self.tedderParticleSystemFlag);
                           if self.isClient then
                               Utils.setEmittingState(v.ps, false);
                           end;
                       end;
                   end;
               end;
           end;
   
           if self.isTurnedOn then
               self.animTime = self.animTime + dt;
               Tedder.setRotorAnimTime(self, self.animTime);
   
               if self.isClient then
                   if not self.tedderSoundEnabled and self:getIsActiveForSound() then
                       playSample(self.tedderSound, 0, self.tedderSoundVolume, 0);
                       setSamplePitch(self.tedderSound, self.tedderSoundPitchOffset);
                       self.tedderSoundEnabled = true;
                   end;
               end;
           end;
   
       end;
   end;
   
   
   
   
   
--***********************************************  DURAL  ***************************************************
--** new speed limit display
local oldTedderDraw = Tedder.draw;
Tedder.draw = function(self)

	if not self.isRealistic then
		return oldTedderDraw(self);
	end;

   if self.isClient then
	   if self:getIsActiveForInput(true) then
		   if self.isTurnedOn then
			   g_currentMission:addHelpButtonText(string.format(g_i18n:getText("turn_off_OBJECT"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
		   else
			   g_currentMission:addHelpButtonText(string.format(g_i18n:getText("turn_on_OBJECT"), self.typeDesc), InputBinding.IMPLEMENT_EXTRA);
		   end;
	   end

	   if self.wasToFast then
		   g_currentMission:addWarning(g_i18n:getText("Dont_drive_to_fast") .. "\n" .. string.format(g_i18n:getText("Cruise_control_levelN"), "2"), 0.07+0.022, 0.019+0.029);
	   end;
   end;
   
end;

